# TFBS module for TFBS::PatternGen::YMF::Motif
#
# Copyright Boris Lenhard and Wynand Alkema
# 
# You may distribute this module under the same terms as perl itself
#

# POD


# POD

=head1 NAME

TFBS::PatternGen::YMF::Motif - class for unprocessed motifs and associated 
numerical scores created by the YMF program


=head1 SYNOPSIS

=head1 DESCRIPTION

TFBS::PatternGen::YMF::Motif is used to store and manipulate unprocessed 
motifs and associated numerical scores created by the ymf program. You do not 
normally want to create a TFBS::PatternGen::YMF::Motif yourself. They are created
by running TFBS::PatternGen::YMF 

=head1 FEEDBACK

Please send bug reports and other comments to the author.

=head1 AUTHOR - Wynand Alkema


Wynand Alkema E<lt>Wynand.Alkema@cgb.ki.seE<gt>

=head1 APPENDIX

The rest of the documentation details each of the object
methods. Internal methods are preceded with an underscore.

=cut



# the code begins here:

package TFBS::PatternGen::YMF::Motif;
use vars qw(@ISA);
use strict;

#use TFBS::Word;
#use TFBS::Word::Consensus;
use TFBS::PatternGen::Motif::Word;
@ISA = qw(TFBS::PatternGen::Motif::Word);


1;






